data SLR_val type_Grammar type_Productions type_Production type_Symbols type_terminal inputType
  = Terminal_val_ type_terminal
  | Parse_Error Int inputType
  | Grammar_val type_Grammar
  | Productions_val type_Productions
  | Production_val type_Production
  | Symbols_val type_Symbols

data Loop a b = Loop (a -> [Loop a b]-> b)

num_Grammar = 1
num_Productions = 2
num_Production = 3
num_Symbols = 4

parse_gram text = get_SLR_val (parse_state1 [Loop go_to_1] [] (scan text))

get_SLR_val val
  = case val of {
     Grammar_val root_val -> root_val;
     Parse_Error state input -> parse_error state input}

parse_state1 states stack []
  = Parse_Error 1 []

parse_state1 states stack input@((s_t,s_v,_):rest)
  = case s_t of
     tok | tok == nonterminal -> parse_state14 (Loop go_to_14 : states) ((Terminal_val_ s_v):stack) rest
     _ -> Parse_Error 1 input


parse_state2 states stack []
  = head stack

parse_state2 states stack input@((s_t,s_v,_):rest)
  = case s_t of
     _ -> Parse_Error 2 input


parse_state3 states stack []
  = Parse_Error 3 []

parse_state3 states stack input@((s_t,s_v,_):rest)
  = case s_t of
     tok | tok == semantic -> parse_state4 (Loop go_to_4 : states) ((Terminal_val_ s_v):stack) rest
     _ -> Parse_Error 3 input


parse_state4 states stack []
  = reduce_1 states stack []

parse_state4 states stack input@((s_t,s_v,_):rest)
  = case s_t of
     _ -> Parse_Error 4 input


parse_state5 states stack []
  = Parse_Error 5 []

parse_state5 states stack input@((s_t,s_v,_):rest)
  = case s_t of
     tok | tok == semantic -> reduce_3 states stack input
     tok | tok == bar -> parse_state7 (Loop go_to_7 : states) ((Terminal_val_ s_v):stack) rest
     tok | tok == nonterminal -> parse_state14 (Loop go_to_14 : states) ((Terminal_val_ s_v):stack) rest
     _ -> Parse_Error 5 input


parse_state6 states stack []
  = Parse_Error 6 []

parse_state6 states stack input@((s_t,s_v,_):rest)
  = case s_t of
     tok | tok == semantic -> reduce_2 states stack input
     _ -> Parse_Error 6 input


parse_state7 states stack []
  = Parse_Error 7 []

parse_state7 states stack input@((s_t,s_v,_):rest)
  = case s_t of
     tok | tok == semantic -> reduce_8 states stack input
     tok | tok == nonterminal -> parse_state10 (Loop go_to_10 : states) ((Terminal_val_ s_v):stack) rest
     tok | tok == terminal -> parse_state12 (Loop go_to_12 : states) ((Terminal_val_ s_v):stack) rest
     _ -> Parse_Error 7 input


parse_state8 states stack []
  = Parse_Error 8 []

parse_state8 states stack input@((s_t,s_v,_):rest)
  = case s_t of
     tok | tok == semantic -> parse_state9 (Loop go_to_9 : states) ((Terminal_val_ s_v):stack) rest
     _ -> Parse_Error 8 input


parse_state9 states stack []
  = Parse_Error 9 []

parse_state9 states stack input@((s_t,s_v,_):rest)
  = case s_t of
     tok | tok == semantic -> reduce_4 states stack input
     tok | tok == bar -> reduce_4 states stack input
     tok | tok == nonterminal -> reduce_4 states stack input
     _ -> Parse_Error 9 input


parse_state10 states stack []
  = Parse_Error 10 []

parse_state10 states stack input@((s_t,s_v,_):rest)
  = case s_t of
     tok | tok == semantic -> reduce_8 states stack input
     tok | tok == nonterminal -> parse_state10 (Loop go_to_10 : states) ((Terminal_val_ s_v):stack) rest
     tok | tok == terminal -> parse_state12 (Loop go_to_12 : states) ((Terminal_val_ s_v):stack) rest
     _ -> Parse_Error 10 input


parse_state11 states stack []
  = Parse_Error 11 []

parse_state11 states stack input@((s_t,s_v,_):rest)
  = case s_t of
     tok | tok == semantic -> reduce_7 states stack input
     _ -> Parse_Error 11 input


parse_state12 states stack []
  = Parse_Error 12 []

parse_state12 states stack input@((s_t,s_v,_):rest)
  = case s_t of
     tok | tok == semantic -> reduce_8 states stack input
     tok | tok == nonterminal -> parse_state10 (Loop go_to_10 : states) ((Terminal_val_ s_v):stack) rest
     tok | tok == terminal -> parse_state12 (Loop go_to_12 : states) ((Terminal_val_ s_v):stack) rest
     _ -> Parse_Error 12 input


parse_state13 states stack []
  = Parse_Error 13 []

parse_state13 states stack input@((s_t,s_v,_):rest)
  = case s_t of
     tok | tok == semantic -> reduce_6 states stack input
     _ -> Parse_Error 13 input


parse_state14 states stack []
  = Parse_Error 14 []

parse_state14 states stack input@((s_t,s_v,_):rest)
  = case s_t of
     tok | tok == arrow -> parse_state15 (Loop go_to_15 : states) ((Terminal_val_ s_v):stack) rest
     _ -> Parse_Error 14 input


parse_state15 states stack []
  = Parse_Error 15 []

parse_state15 states stack input@((s_t,s_v,_):rest)
  = case s_t of
     tok | tok == semantic -> reduce_8 states stack input
     tok | tok == nonterminal -> parse_state10 (Loop go_to_10 : states) ((Terminal_val_ s_v):stack) rest
     tok | tok == terminal -> parse_state12 (Loop go_to_12 : states) ((Terminal_val_ s_v):stack) rest
     _ -> Parse_Error 15 input


parse_state16 states stack []
  = Parse_Error 16 []

parse_state16 states stack input@((s_t,s_v,_):rest)
  = case s_t of
     tok | tok == semantic -> parse_state17 (Loop go_to_17 : states) ((Terminal_val_ s_v):stack) rest
     _ -> Parse_Error 16 input


parse_state17 states stack []
  = Parse_Error 17 []

parse_state17 states stack input@((s_t,s_v,_):rest)
  = case s_t of
     tok | tok == semantic -> reduce_5 states stack input
     tok | tok == bar -> reduce_5 states stack input
     tok | tok == nonterminal -> reduce_5 states stack input
     _ -> Parse_Error 17 input



reduce_1 (_:_:states@(Loop state : _))
          (Terminal_val_ x2 : Productions_val x1 : rest)
    = state num_Grammar states ((Grammar_val ( 

	let { (ps,ss) = unzip x1 ;
			unzip [] = ([],[]) ;
			unzip ((a,b):l) = let {(as,bs) = unzip l}
					  in (a:as,b:bs) ;
			extract_terminals
				= nub . concat . map (lefts . snd) ;
			lefts []            = [] ;
			lefts (Left t : ss) = t : lefts ss ;
			lefts (_ : ss)      = lefts ss }
		    in ((extract_terminals ps,
			 nub (map fst ps),ps,
			 fst (head ps)),
			ss,
			init (tail x2))
						)) : rest)

reduce_2 (_:_:states@(Loop state : _))
          (Productions_val x2 : Production_val x1 : rest)
    = state num_Productions states ((Productions_val ( x1++x2 )) : rest)

reduce_3 (_:states@(Loop state : _))
          (Production_val x1 : rest)
    = state num_Productions states ((Productions_val ( x1 )) : rest)

reduce_4 (_:_:_:_:states@(Loop state : _))
          (Terminal_val_ x4 : Symbols_val x3 : Terminal_val_ x2 : Production_val x1 : rest)
    = state num_Production states ((Production_val ( (((fst . fst . head) x1,x3),init (tail x4)):x1 )) : rest)

reduce_5 (_:_:_:_:states@(Loop state : _))
          (Terminal_val_ x4 : Symbols_val x3 : Terminal_val_ x2 : Terminal_val_ x1 : rest)
    = state num_Production states ((Production_val ( [((x1,x3),init (tail x4))] )) : rest)

reduce_6 (_:_:states@(Loop state : _))
          (Symbols_val x2 : Terminal_val_ x1 : rest)
    = state num_Symbols states ((Symbols_val ( Left x1 : x2 )) : rest)

reduce_7 (_:_:states@(Loop state : _))
          (Symbols_val x2 : Terminal_val_ x1 : rest)
    = state num_Symbols states ((Symbols_val ( Right x1 : x2 )) : rest)

reduce_8 (states@(Loop state : _))
          (rest)
    = state num_Symbols states ((Symbols_val ( [] )) : rest)


go_to_1 nont states
   | nont == num_Grammar = parse_state2 (Loop go_to_2 : states)
   | nont == num_Productions = parse_state3 (Loop go_to_3 : states)
   | nont == num_Production = parse_state5 (Loop go_to_5 : states)

go_to_2 = go_to_2

go_to_3 = go_to_3

go_to_4 = go_to_4

go_to_5 nont states
   | nont == num_Productions = parse_state6 (Loop go_to_6 : states)
   | nont == num_Production = parse_state5 (Loop go_to_5 : states)

go_to_6 = go_to_6

go_to_7 nont states
   | nont == num_Symbols = parse_state8 (Loop go_to_8 : states)

go_to_8 = go_to_8

go_to_9 = go_to_9

go_to_10 nont states
   | nont == num_Symbols = parse_state11 (Loop go_to_11 : states)

go_to_11 = go_to_11

go_to_12 nont states
   | nont == num_Symbols = parse_state13 (Loop go_to_13 : states)

go_to_13 = go_to_13

go_to_14 = go_to_14

go_to_15 nont states
   | nont == num_Symbols = parse_state16 (Loop go_to_16 : states)

go_to_16 = go_to_16

go_to_17 = go_to_17




type Gram terminal nonterminal
	= ([terminal],[nonterminal],[Production terminal nonterminal],nonterminal)

type Production terminal nonterminal
	= (nonterminal,[Either terminal nonterminal])

data Either a b = Left a | Right b

instance (Eq a, Eq b) => Eq (Either a b) where
	Left a  == Left a1  = a == a1
	Right b == Right b1 = b == b1
	_       == _	    = False

type Item terminal nonterminal
	= (nonterminal,[Either terminal nonterminal],[Either terminal nonterminal])

instance (Eq n, Eq [Either t n]) => Eq (Item t n) where
	(n,b,a) == (n1,b1,a1) = n==n1 && b==b1 && a==a1 

