/*****************************************************************************

  mac_ctype.h:  Copyright (c) Kevin Hammond 1993.   All rights reserved.
  
  8-bit character classification for the Mac.
 

*****************************************************************************/
  
#ifndef __MCTYPE__
#define __MCTYPE__

#if MPW
#define _U		 01
#define _L		 02
#define _N		 04
#define _S		 010
#define _P		 020
#define _C		 040
#define _B		 0100
#define _X		 0200
#define _Y		 0100
#define _ctype	_mctype

/*
	Because Mark has declared c0/c1 to be int, the character
	classification routines fail for non-ASCII characters.
	These versions perform a suitable coercion first.
*/

#undef  isalpha
#undef	isupper
#undef	islower
#undef	isdigit
#undef	isxdigit
#undef	isalnum
#undef	isspace
#undef	ispunct
#undef  isascii
#undef  isprint
#define isalpha(c)	((_ctype+1)[(unsigned char) c]&(_U|_L))
#define isupper(c)	((_ctype+1)[(unsigned char) c]&_U)
#define islower(c)	((_ctype+1)[(unsigned char) c]&_L)
#define isdigit(c)	((_ctype+1)[(unsigned char) c]&_N)
#define isxdigit(c)	((_ctype+1)[(unsigned char) c]&_X)
#define isalnum(c)	((_ctype+1)[(unsigned char) c]&(_U|_L|_N))
#define isspace(c)	((_ctype+1)[(unsigned char) c]&_S)
#define ispunct(c)	((_ctype+1)[(unsigned char) c]&_P)
#define issymb(c)	((_ctype+1)[(unsigned char)c]&_Y)
#define isascii(c)	TRUE
#define isprint(c)	TRUE	/* In some font or other */

extern char _ctype[];

#else
#include <ctype.h>
#endif
#endif
