/*********************************************************************

	Mac-Specific Include Files

*********************************************************************/

#include <SANE.h>       	/*  Apple Maths Libraries	    */
#include <Values.h>     	/*  Maths type sizes 		    */
#include <Types.h>      	/*  Basic type definitions 	    */
#include <Memory.h>     	/*  Memory structure types 	    */
#include <Resources.h>  	/*  Resource Manager 		    */
#include <Quickdraw.h>  	/*  QuickDraw			    */
#include <Fonts.h>      	/*  Font Manager 		    */
#include <Events.h>     	/*  Event Manager 		    */
#include <Controls.h>   	/*  Control Manager 		    */
#include <Windows.h>    	/*  Window Manager 		    */
#include <Menus.h>      	/*  Menu Manager 		    */
/*#include "FakeTextEdit.h"	/*  Fake TextEdit Routines		    */
#include <TextEdit.h>   	/*  TextEdit Manager 		    */
#include <Dialogs.h>    	/*  Dialog Manager 		    */
#include <Desk.h>       	/*  Desktop Manager 		    */
#include <ToolUtils.h>  	/*  Toolbox utilities 		    */
#include <SegLoad.h>    	/*  Segment Loader		    */
#include <OSUtils.h>    	/*  OS utilities 		    */
#include <Files.h>      	/*  File Manager		    */
#include <OSEvents.h>   	/*  OS events 			    */
#include <DiskInit.h>   	/*  Disk Initialisation 	    */
#include <Packages.h>   	/*  Packages, e.g. SFGetFile 	    */
#include <Lists.h>      	/*  List manager 		    */
#if !THINKC
#include <CursorCtl.h>  	/*  Cursor Manager 		    */
#include <Strings.h>    	/*  p2cstr 			    */
#endif
#include <Scrap.h>      	/*  Scrap Manager 		    */
#include <Errors.h>		/*  Error Messages                  */
#include <Folders.h>		/*  Folder Headers                  */
#include <Aliases.h>		/*  Alias Headers                  */

#include "mac_print.h"		/*  Print Headers 		    */
#include "setjmp.h"		/*  Longjmp Headers 		    */
#include "mac_humayan_utils.h"	/*  Routines for HSL changes	    */

extern dlgarrowkey(ListHandle list,Boolean up);	

extern resetDlgSearch(ListHandle list,Boolean casesens);

extern findcellmatching(char match[],short size,ListHandle list,
                        Cell *from,Boolean casesens);

extern int equalitems(char *i1, char *i2, int len,Boolean casesens);

extern Boolean GetDlgItemETVal();
extern pascal Boolean ListDlgFilter();

extern Boolean revertdialog(), oktosavedialog(), fileIsLocked(),
               isVolLocked(), isUserLocked();

extern Boolean CheckError(char *file, short action, OSErr result);

extern Boolean DoFileSearch(char **file,short *volnum,long *dirID);

extern Boolean LookForFileInProject(char **file,short *volnum,long *dirID);

extern Boolean doreadproject(),   dorestoreprefs(), handle_write_error(),
               checkFileExists(), dowrite(),        dosave(),
	       revertdialog(),    oktosavedialog(), findLine(),
	       equalstrings(),    saveas(),         searchForText(),
	       SelIsSearch(),     cursorkey(),      findnl(),
	       Terminate_Gofer(), closethewindow(), getprojfile(),
	       getfilefor(),      smallerstring(),  IsADuplicate(),
	       TrapAvailable(),   closethewindow(), closeallwindows();

extern void SafeHLock  ( Handle h, Boolean *saveLock );
extern void SafeHUnlock( Handle h, Boolean saveLock );
extern savedir(short vrefnum, long dirID, Boolean reset);
extern pascal Boolean projectFileFilter();
extern pascal Boolean AutoScroll();
extern Boolean selected(void);
