SYSTEM compute_pi;
(* parallel reference algorithm, used by R. Babb *)
CONST intervalls = 100;
      width      = 1.0 / FLOAT(intervalls);
CONFIGURATION list [1..intervalls];
CONNECTION (* none *);

VECTOR val: REAL;

PROCEDURE f (VECTOR x: REAL): VECTOR REAL;
(* function to be integrated *)
BEGIN
  RETURN(4.0 / (1.0 + x*x))
END f;

BEGIN
  PARALLEL
    (* integral approximation with rectangle-rule *)
    val := width * f( (FLOAT(id_no)-0.5) * width );
  ENDPARALLEL;
  WriteReal(REDUCE.SUM(val), 15);
END compute_pi.

