% Changes to make spider work on an Apple Macintosh
%
% Matthias Neeracher <neeri@@iis.ethz.ch> 20Feb93
%

%
% We have to use a different approach to parsing the time string, so we might as well make
% it simpler at the same time
%

#x
#*1Tracking the generation date.
We want to be able to note the date on which we generate files.
#<Patt...#>=
#=/^date /#>	{
	## date returned as ``Fri Dec 11 11:31:18 EST 1987''
	mo = month[$3]
	day = $4
	year = $7
	time = $5
	#<Set |hour|, |minute|, and |ampm| from |time|#>
	date = sprintf ("(generated at %d:%s %s on %s %d, %d)",\
		hour, minute, ampm, mo, day, year)
	next
}

# We want the months to have their full names
#<Set init...#>=
month["Jan"]="January"
month["Feb"]="February"
month["Mar"]="March"
month["Apr"]="April"
month["May"]="May"
month["Jun"]="June"
month["Jul"]="July"
month["Aug"]="August"
month["Sep"]="September"
month["Oct"]="October"
month["Nov"]="November"
month["Dec"]="December"

# We make a ``friendly'' time from |time=="hh:mm:ss"|.
#<Set |hour|, |minute|, and |ampm| from |time|#>=
	hour = substr(time,1,2)
	if (hour >=12)
		ampm = "PM"
	else
		ampm="AM"
	
	if (hour==0) {
		hour =12
	} else if (hour>12) {
		hour = hour -12
	}
	minute = substr(time,4,2)
#y
#*1Tracking the generation date.
We want to be able to note the date on which we generate files.
#<Patt...#>=
#=/^date /#>	{
	date = sprintf("(generated %s)", substr($0, 5, 40))
	next
}
#z
