% Changes to make tangle work on an Apple Macintosh
%
% Matthias Neeracher <neeri@@iis.ethz.ch> 20Feb93
%

%
% MPW dislikes large global areas.
%

@x
@ @<Glob...@>=
text text_info[max_texts];
text_pointer text_info_end=text_info+max_texts-1;
text_pointer text_ptr; /* first unused position in |text_info| */
eight_bits tok_mem[max_toks];
eight_bits *tok_mem_end=tok_mem+max_toks-1;
eight_bits *tok_ptr; /* first unused position in |tok_mem| */

@ @<Set init...@>=
text_info->tok_start=tok_ptr=tok_mem;
text_ptr=text_info+1; text_ptr->tok_start=tok_mem;
  /* this makes replacement text 0 of length zero */
@y
@ @<Glob...@>=
text text_info[max_texts];
text_pointer text_info_end=text_info+max_texts-1;
text_pointer text_ptr; /* first unused position in |text_info| */
eight_bits *tok_mem;
eight_bits *tok_mem_end;
eight_bits *tok_ptr; /* first unused position in |tok_mem| */

@ @<Set init...@>=
tok_mem=(eight_bits *) malloc(max_toks);
tok_mem_end=tok_mem+max_toks-1;
text_info->tok_start=tok_ptr=tok_mem;
text_ptr=text_info+1; text_ptr->tok_start=tok_mem;
  /* this makes replacement text 0 of length zero */
@z

%
% Track line numbers during phase 2
%

@x
@ If |p| is a pointer to a module name, |p->equiv| is a pointer to its
@y
@ @<Glob...@>=
sixteen_bits phase_two_line;
int          phase_two_file;

@ @<Set init...@>=
phase_two_line = 0;

@ If |p| is a pointer to a module name, |p->equiv| is a pointer to its
@z

%
% This seems to be a small bug
%

@x
@u sixteen_bits
get_output() /* returns next token after macro expansion */
{ 
  sixteen_bits a; /* value of current byte */
  restart: if (stack_ptr==stack) return 0;
  if (cur_byte==cur_end) {
    cur_val=-((int)cur_mod); /* cast needed because of sign extension */
    pop_level();
    if (cur_val==0) goto restart;
    out_char(module_number); return;
  }
@y
@u sixteen_bits
get_output() /* returns next token after macro expansion */
{ 
  sixteen_bits a; /* value of current byte */
  restart: if (stack_ptr==stack) return 0;
  if (cur_byte==cur_end) {
    cur_val=-((int)cur_mod); /* cast needed because of sign extension */
    pop_level();
    if (cur_val==0) goto restart;
    out_char(module_number); return 1;
  }
@z

%
% Cosmetical correction to make error messages MPW style
%

@x
		if (stack_ptr==stack || *cur_byte!=@`(') {
			printf("\n! No parameters given for ");
			print_id(a+name_dir);
@y
		if (stack_ptr==stack || *cur_byte!=@`(') {
			printf("\n# No parameters given for ");
			print_id(a+name_dir);
@z

%
% Slightly more than cosmetics
%

@x
  if ((a+name_dir)->equiv!=(ASCII *)text_info) push_level(a+name_dir);
  else if (a!=0) {
    printf("\n! Not present: <"); print_id(a+name_dir); err_print(">");
@.Not present: <section name>@>
@y
  if ((a+name_dir)->equiv!=(ASCII *)text_info) push_level(a+name_dir);
  else if (a!=0) {
    eight_bits * j;
    printf("\n# ! Not present: <"); print_id(a+name_dir); putchar('>'); 
	 printf("\nFile '");
    for (j=(phase_two_file+name_dir)->byte_start; j<(name_dir+phase_two_file+1)->byte_start;
      j++) putchar(*j);
	 printf("'; Line %d\n", phase_two_line);
    fflush(stdout); mark_error;	 
@.Not present: <section name>@>
@z

%
% Spin Cursor, track phase two line
%

@x
@u flush_buffer() /* writes one line to output file */
{
  C_putc('\n');
  if (cur_line % 100 == 0) {
    printf(".");
    if (cur_line % 500 == 0) printf("%d",cur_line);
    update_terminal; /* progress report */
  }
  cur_line++;
}
@y
@u flush_buffer() /* writes one line to output file */
{
  C_putc('\n');
  SpinCursor(-1);
  if (cur_line % 100 == 0) {
    printf(".");
    if (cur_line % 500 == 0) printf("%d",cur_line);
    update_terminal; /* progress report */
  }
  cur_line++;
  if (phase_two_line)
    phase_two_line++;
}
@z

%
% More cosmetica
%

@x
    if(end_output_files==cur_out_file) {
      printf("\n! No program text was specified."); mark_harmless;
@.No output was specified@>
@y
    if(end_output_files==cur_out_file) {
      printf("\n# ! No program text was specified."); mark_harmless;
@.No output was specified@>
@z

%
% Track line numbers
%

@x
    sixteen_bits a;
    a=@'400* *cur_byte++;
    a+=*cur_byte++; /* gets the line number */
    C_printf("\n%s",sharp_line_open);
    C_printf(" %d \"",a);
    cur_val=*cur_byte++;
    cur_val=@'400*(cur_val-@'200)+ *cur_byte++; /* points to the file name */
    for (j=(cur_val+name_dir)->byte_start; j<(name_dir+cur_val+1)->byte_start;
      j++) C_putc(*j);
    C_printf("\"%s\n",sharp_line_close);
@y
    sixteen_bits a;
    a=@'400* *cur_byte++;
    a+=*cur_byte++; /* gets the line number */
    cur_val=*cur_byte++;
    cur_val=@'400*(cur_val-@'200)+ *cur_byte++; /* points to the file name */
	 phase_two_file = cur_val;
	 phase_two_line = a;
    C_printf("\n%s",sharp_line_open);
    C_printf(" %d \"",a);
    for (j=(cur_val+name_dir)->byte_start; j<(name_dir+cur_val+1)->byte_start;
      j++) C_putc(*j);
    C_printf("\"%s\n",sharp_line_close);
@z

%
% Still more cosmetica
%

@x
  if (id_loc>=mod_text_end) {
    printf("\n! String too long: ");
@.String too long@>
    ASCII_write(mod_text+1,25);
    printf("..."); mark_error;
  }
@y
  if (id_loc>=mod_text_end) {
    printf("\n# ! String too long: ");
@.String too long@>
    ASCII_write(mod_text+1,25);
    printf("..."); mark_error;
  }
@z

@x
if (k>=mod_text_end) {
  printf("\n! Section name too long: ");
@.Section name too long@>
  ASCII_write(mod_text+1,25);
  printf("..."); mark_harmless;
}
@y
if (k>=mod_text_end) {
  printf("\n# ! Section name too long: ");
@.Section name too long@>
  ASCII_write(mod_text+1,25);
  printf("..."); mark_harmless;
}
@z

@x
		printf("\n! Warning: macro name ");
		print_id(p);
		printf(" was used before it was defined");
@y
		printf("\n# ! Warning: macro name ");
		print_id(p);
		printf(" was used before it was defined");
@z
