/*
 *	Flex.r	-	resources for MPW port of GNU Flex
 *
 *	Based on Matt Holiday's port of 2.3.7
 *	Franklin Chen
 *	Version 2.3.8	Fri, Mar 26, 1993
 *	Version 2.4.6	Sat, Feb 19, 1994
 */

#include "Types.r"
#include "SysTypes.r"
#include "Cmdo.r"

resource 'vers' (1) {
	0x2,
	0x46,
	release,
	0x0,
	verUS,
	"2.4.6",
	"2.4.6 by Vern Paxson  The Regents of the U. of C., "
	"FSF, Inc."
};

resource 'vers' (2) {
	0x2,
	0x46,
	release,
	0x0,
	verUS,
	"2.4.6",
	"GNU for MPW"
};

resource 'cmdo' (128, "Flex") {
	{	/* array dialogs: 1 elements */
		/* [1] */
		299,
		"GNU scanner generator.  See Flex(1) for "
		"more information.",
		{	/* array itemArray: 17 elements */
			/* [1] */
			NotDependent {

			},
			Files {
				InputFile,
				RequiredFile {
					{17, 14, 37, 117},
					"Flex File",
					"",
					"Select a file of lexical specifications."
				},
				Additional {
					"",
					".l",
					"Only files ending in .l",
					"All text files",
					{	/* array TypesArray: 1 elements */
						/* [1] */
						text
					}
				}
			},
			/* [2] */
			Or {
				{	/* array OrArray: 1 elements */
					/* [1] */
					1
				}
			},
			Redirection {
				StandardOutput,
				{14, 351}
			},
			/* [3] */
			Or {
				{	/* array OrArray: 1 elements */
					/* [1] */
					1
				}
			},
			Redirection {
				DiagnosticOutput,
				{54, 351}
			},
			/* [4] */
			Or {
				{	/* array OrArray: 4 elements */
					/* [1] */
					4111,
					/* [2] */
					8207,
					/* [3] */
					12303,
					/* [4] */
					16399
				}
			},
			CheckOption {
				NotSet,
				{48, 173, 64, 287},
				"Interactive",
				"-I",
				"Generate an interactive scanner."
			},
			/* [5] */
			Or {
				{	/* array OrArray: 1 elements */
					/* [1] */
					1
				}
			},
			CheckOption {
				NotSet,
				{20, 136, 36, 316},
				"Write to StdOut",
				"-t",
				"Write the generated scanner to standard output in"
				"stead of lex.yy.c."
			},
			/* [6] */
			Or {
				{	/* array OrArray: 1 elements */
					/* [1] */
					1
				}
			},
			CheckOption {
				NotSet,
				{76, 173, 92, 334},
				"Case insensitive",
				"-i",
				"Generate a case-insensitive scanner."
			},
			/* [7] */
			Or {
				{	/* array OrArray: 1 elements */
					/* [1] */
					1
				}
			},
			CheckOption {
				NotSet,
				{94, 173, 110, 334},
				"8-bit scanner",
				"-8",
				"Generate a scanner which can recognize 8"
				"-bit characters."
			},
			/* [8] */
			Or {
				{	/* array OrArray: 1 elements */
					/* [1] */
					1
				}
			},
			CheckOption {
				NotSet,
				{134, 173, 150, 334},
				"Debugging scanner",
				"-d",
				"Generate a scanner which runs in debug m"
				"ode."
			},
			/* [9] */
			Or {
				{	/* array OrArray: 1 elements */
					/* [1] */
					1
				}
			},
			CheckOption {
				NotSet,
				{152, 173, 168, 334},
				"Suppress default rule",
				"-s",
				"Suppress the default rule writing unmatc"
				"hed input to standard output; instead, abort with"
				" an error."
			},
			/* [10] */
			Or {
				{	/* array OrArray: 1 elements */
					/* [1] */
					1
				}
			},
			CheckOption {
				NotSet,
				{170, 173, 186, 334},
				"No #line directives",
				"-L",
				"Do not generate #line directives in the "
				"scanner."
			},
			/* [11] */
			Or {
				{	/* array OrArray: 1 elements */
					/* [1] */
					1
				}
			},
			CheckOption {
				NotSet,
				{98, 349, 114, 472},
				"Backtracking",
				"-b",
				"Generate backtracking information to lex"
				".backup."
			},
			/* [12] */
			Or {
				{	/* array OrArray: 1 elements */
					/* [1] */
					1
				}
			},
			CheckOption {
				NotSet,
				{128, 349, 144, 472},
				"Performance",
				"-p",
				"Write a performance report to diagnostic output upo"
				"n completion."
			},
			/* [13] */
			Or {
				{	/* array OrArray: 1 elements */
					/* [1] */
					1
				}
			},
			CheckOption {
				NotSet,
				{146, 349, 162, 472},
				"Verbose",
				"-v",
				"Write to diagnostic output a summary of statistics "
				"regarding the generated scanner."
			},
			/* [14] */
			Or {
				{	/* array OrArray: 1 elements */
					/* [1] */
					1
				}
			},
			CheckOption {
				NotSet,
				{170, 349, 186, 472},
				"Trace",
				"-T",
				"Run in trace mode: generate messages to "
				"standard output concerning the form of the input "
				"and the resultant finite automata."
			},
			/* [15] */
			Or {
				{	/* array OrArray: 1 elements */
					/* [1] */
					1
				}
			},
			RadioButtons {
				{	/* array radioArray: 8 elements */
					/* [1] */
					{57, 16, 73, 150}, "Compress/Full", "-Cem", Set, "Use equivalence & meta-equivalence class"
					"es, compress tables.",
					/* [2] */
					{73, 16, 89, 150}, "Compress/Meta", "-Cm", NotSet, "Use only meta-equivalence classes, compr"
					"ess tables.",
					/* [3] */
					{89, 16, 105, 150}, "Compress/Equiv", "-Ce", NotSet, "Use only equivalence classes, compress t"
					"ables.",
					/* [4] */
					{105, 16, 121, 150}, "Compress only", "-C", NotSet, "Compress tables without equivalence or m"
					"eta-equivalence tables.",
					/* [5] */
					{121, 16, 137, 150}, "Full/Equiv", "-Cfe", NotSet, "Use equivalence classes but don't compre"
					"ss tables.",
					/* [6] */
					{137, 16, 153, 150}, "Fast/Equiv", "-CFe", NotSet, "Fast scanner with equivalence classes.",
					/* [7] */
					{153, 16, 169, 150}, "Full tables", "-Cf", NotSet, "Generate scanner with full, non-compress"
					"ed tables.",
					/* [8] */
					{169, 16, 185, 150}, "Fast scanner", "-CF", NotSet, "Generate fast scanner."
				}
			},
			/* [16] */
			NotDependent {

			},
			TextBox {
				gray,
				{49, 10, 191, 160},
				"Table Compression"
			},
			/* [17] */
			NotDependent {},
			VersionDialog {
				VersionString {
					"2.4.6"
				},
				"by Vern Paxson  1990 The Regents of the University"
				" of California. Portions  Free Software Foundation, Inc.\nMPW port by Matt Holiday and Franklin Chen.",
				noDialog
			},
			/* [18] */
			Or {
				{	/* array OrArray: 1 elements */
					/* [1] */
					1
				}
			},
			DoItButton {

			}
		}
	}
};

