# ----------------------------------------------------------------------
# FSPLIT makefile for the Macintosh MPW Shell 3.2.
# ----------------------------------------------------------------------
#   Target:     fsplit
#   Sources:    fsplit.c  GUSI.o
#   Created:    Friday, April 30, 1993
# ----------------------------------------------------------------------
# This software was ported to the Macintosh by:
#
# Fred Walsteijn   (E-mail:  walsteyn@fys.ruu.nl)
# Institute for Marine and Atmospheric Research
# Utrecht University
# Princetonplein 5
# 3584 CC Utrecht
# The Netherlands
# ----------------------------------------------------------------------
# The Unix-based code needed only minor changes because the Unix library
# functions from GUSI.o are used.
# GUSI has been made available by Matthias Neeracher (neeri@iis.ethz.ch).
# ----------------------------------------------------------------------
# To recompile this tool, do the following:
#
# 1. Make sure that the variable {MPWversion} has been exported by the Shell.
# 2. Substitute the actual version number of the GUSI library you are using
#    in the following line:
GUSIversion = 1.1.1 
# 3. After the build of fsplit, use ResEdit to create a new resource in it
#    with type GUI.  The Rez command below has written a template for this
#    type in the resource fork of the tool fsplit.
#    Set the autoSpin value in the new resource to one of 2, 4, 8, 16, or 32;
#    and also set the type and creator of the output file.
#    Change the ID of the new resource to 10240.

VERSION  = 1.1.1
OBJECTS  = fsplit.c.o
DEFINES  = -d MPW
COPTIONS = -model far -mc68020 -mc68881 -elems881 -sym off -mbg off
LOPTIONS = -model far -d -w -c 'MPS ' -t MPST -mf -ad 4 -ac 4 -sym off

fsplit			"{RIncludes}"GUSI.r
	Rez "{RIncludes}"GUSI.r -o fsplit -append    # -d GUSI_PREF_VERSION='0110'

fsplit			{OBJECTS}
	Link {LOPTIONS} 
		 {OBJECTS} 
		"{CLibraries}"GUSI.o 
		"{Libraries}"Stubs.o 
		"{Libraries}"ToolLibs.o 
		"{CLibraries}"Clib881.o 
		"{CLibraries}"CSANELib881.o 
		"{CLibraries}"Math881.o 
		"{CLibraries}"Complex881.o 
		"{CLibraries}"StdClib.o 
		"{Libraries}"Interface.o 
		"{Libraries}"Runtime.o 
		-o fsplit

fsplit.c.o			fsplit.c
	 C {COPTIONS} {DEFINES}  fsplit.c

fsplit			fsplit.make
	SetVersion fsplit -version "{VERSION}" -t vers -i 1 -d 
			-verstring "^,  Fred Walsteijn 1993  (walsteyn@fys.ruu.nl)"
	SetVersion fsplit -version "{MPWversion}" -t vers -i 2 
			-verstring "MPW {MPWversion} / GUSI {GUSIversion}" 
 			 Dev:Null || Set Status 0
	# fsplit is built in the current MPW Shell using GUSI of specified version
	# (works only if MPWversion has been exported)
