/*
	String-extras.h
	
	There are two ways to use this file.

		1. use `#include <String-extras.h>'
		
			or
		
		2. Copy these declarations to the end of the stock String.h file

	Copyright (c) 1993 Anthony C. Ard.

	This program is free software; you can redistribute it and/or
	modifiy it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 2
	of the License, or (at your option) any later version.
	
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
	GNU General Public License for more details.
	
	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#ifndef String-extras_h
#define String-extras_h

#include <StdLib.h>

#ifdef __cplusplus
extern "C" {
#endif

char *index( const char *s1, int c );
char *rindex( const char *s1, int c );
void *bcopy( const void *a1, void *a2, size_t size );
void *bzero( void *a1, size_t size );
int bcmp( const void *a1, const void *a2, size_t n );

int strcasecmp( char *s1, char *s2 );
int strncasecmp( char *s1, char *s2, int n );

char *strdup( const char *src );

#ifdef __cplusplus
}
#endif

#endif String-extras_h
