/*
	gzip.r -- commando definition for gzip

	Copyright (c) 1993 Anthony C. Ard.

	This program is free software; you can redistribute it and/or
	modifiy it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 2
	of the License, or (at your option) any later version.
	
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
	GNU General Public License for more details.
	
	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#include "cmdo.r"

resource 'cmdo' (128) {
	{	/* array dialogs: 2 elements */
		/* [1] */
		310,
		"gzip -- compress or expand files.",
		{	/* array itemArray: 14 elements */
			/* [1] */
			NotDependent {

			},
			RadioButtons {
				{	/* array radioArray: 4 elements */
					/* [1] */
					{42, 52, 57, 177}, "Compress file(s)", "", Set, "When this button is selected, gzip will compress the given f"
					"ile(s). (This is the default behavior of gzip.)",
					/* [2] */
					{60, 52, 76, 198}, "Decompress file(s)", "-d", NotSet, "When this button is selected, gzip will decompress file(s) e"
					"nding in .Z, .gz, or .z.",
					/* [3] */
					{79, 52, 95, 198}, "List contents", "-l", NotSet, "When this button is selected, gzip will list the contents of"
					" compressed files ending in .Z, .gz, or .z.",
					/* [4] */
					{98, 52, 114, 198}, "Test file", "-t", NotSet, "When this button is selected, gzip will test the contents of"
					" compressed files ending in .Z, .gz, or .z."
				}
			},
			/* [2] */
			NotDependent {

			},
			TextBox {
				black,
				{30, 29, 121, 221},
				"Conversion"
			},
			/* [4] */
			NotDependent {

			},
			CheckOption {
				NotSet,
				{31, 250, 47, 441},
				"Write to standard output",
				"-c",
				"Write to standard output and do not remove original files."
			},
			/* [5] */
			NotDependent {

			},
			CheckOption {
				NotSet,
				{49, 250, 65, 462},
				"Display progress information (verbose)",
				"-v",
				"Show name and ratio for each file processed."
			},
			/* [6] */
			NotDependent {

			},
			CheckOption {
				NotSet,
				{67, 250, 83, 444},
				"Show version information",
				"-V",
				"Show the programs version number and author."
			},
			/* [7] */
			NotDependent {

			},
			CheckOption {
				NotSet,
				{85, 250, 101, 425},
				"Show help information",
				"-h",
				"Show all help information that describes all the functions of gzip."
			},
			/* [8] */
			NotDependent {

			},
			CheckOption {
				NotSet,
				{103, 250, 120, 461},
				"Show license information",
				"-L",
				"Show version, author, and GNU license information."
			},
			/* [3] */
			NotDependent {

			},
			NestedDialog {
				2,
				{131, 252, 151, 451},
				"More Options",
				"Click this button to choose additional gzip options."
			},
			/* [9] */
			NotDependent {

			},
			MultiFiles {
				"File(s) to convert",
				"Click this button to choose the files you wish to convert.",
				{131, 29, 151, 221},
				"File(s) to Convert:",
				"",
				MultiInputFiles {
					{	/* array MultiTypesArray: 1 elements */
						/* [1] */
						text
					},
					FilterTypes,
					"only text files",
					"All files      "
				}
			},
			/* [10] */
			NotDependent {

			},
			Redirection {
				StandardInput,
				{160, 37}
			},
			/* [11] */
			NotDependent {

			},
			Redirection {
				StandardOutput,
				{160, 183}
			},
			/* [12] */
			NotDependent {

			},
			Redirection {
				DiagnosticOutput,
				{160, 329}
			},
			/* [13] */
			NotDependent {

			},
			DoItButton {

			},
			/* [14] */
			NotDependent {

			},
			VersionDialog {
				VersionString {
					"1.2.2"
				},
				"Version 1.2.2, Copyright  1993 Free Software Foundation."
				" Commando dialog by Anthony C. Ard. Use the -L option for more information.",
				noDialog
			}
		},
		/* [2] */
		280,
		"Choose additional gzip options.",
		{	/* array itemArray: 8 elements */
			/* [1] */
			NotDependent {

			},
			CheckOption {
				NotSet,
				{51, 240, 68, 411},
				"ASCII text",
				"-a",
				"Convert end-of-lines using local conventions. "
				"(Doesn't really do anything on the Mac.)"
			},
			/* [2] */
			NotDependent {

			},
			CheckOption {
				NotSet,
				{69, 240, 86, 411},
				"Force overwrite",
				"-f",
				"Force overwrite of output file and compress links. "
				"(MacOS version doesn't support links.)"
			},
			/* [3] */
			NotDependent {

			},
			CheckOption {
				NotSet,
				{87, 240, 104, 411},
				"Don't store name",
				"-n",
				"Do not save or restore the original name."
			},
			/* [4] */
			NotDependent {

			},
			CheckOption {
				NotSet,
				{105, 240, 122, 411},
				"Suppress all warnings",
				"-q",
				"Supresses all warnings."
			},
			/* [5] */
			NotDependent {

			},
			CheckOption {
				NotSet,
				{123, 240, 140, 411},
				"Recurse directories",
				"-r",
				"Recurse one level deep through directories."
			},
			/* [6] */
			NotDependent {

			},
			RadioButtons {
				{	/* array radioArray: 9 elements */
					/* [1] */
					{57, 81, 72, 111}, "1", "-1", NotSet, "Fastest with least compression.",
					/* [2] */
					{74, 81, 89, 111}, "2", "-2", NotSet, "Faster with lesser compression.",
					/* [3] */
					{92, 81, 107, 111}, "3", "-3", NotSet, "Faster with lesser compression.",
					/* [4] */
					{57, 121, 72, 151}, "4", "-4", NotSet, "Faster with lesser compression.",
					/* [5] */
					{74, 121, 89, 151}, "5", "-5", NotSet, "Faster with lesser compression.",
					/* [6] */
					{92, 121, 107, 151}, "6", "", Set, "Default. Good speed. Good compression.",
					/* [7] */
					{57, 161, 72, 191}, "7", "-7", NotSet, "Slower with more compression.",
					/* [8] */
					{74, 161, 89, 191}, "8", "-8", NotSet, "Slower with more compression.",
					/* [9] */
					{92, 161, 107, 191}, "9", "-9", NotSet, "Slowest with most comprssion"
				}
			},
			/* [7] */
			NotDependent {

			},
			TextBox {
				black,
				{43, 66, 116, 206},
				"Compression Ratio"
			},
			/* [8] */
			NotDependent {

			},
			RegularEntry {
				"Suffix",
				{129, 75, 145, 120},
				{129, 122, 145, 203},
				"",
				keepCase,
				"-S",
				"use/look for this suffix instead of .gz, .Z, or .z."
			}
		}
	}
};

